const prefix = 'amf';

const keyFormat = (key: string) => {
  let result = '';

  result += prefix ? `${prefix}_` : '';
  result += key;

  return result;
};

const storage = {
  setItemSync: async (key: string, value: any) => {
    await null;
    localStorage.setItem(keyFormat(key), JSON.stringify(value));
  },
  getItemSync: async (key: string) => {
    await null;
    const value = localStorage.getItem(keyFormat(key));
    return value ? JSON.parse(value) : null;
  },
  removeItemSync: async (key: string) => {
    await null;
    localStorage.removeItem(keyFormat(key));
  },
  clearSync: async () => {
    await null;
    localStorage.clear();
  },
  setItem: (key: string, value: any) => {
    localStorage.setItem(keyFormat(key), JSON.stringify(value));
  },
  getItem: (key: string) => {
    const value = localStorage.getItem(keyFormat(key));
    return value ? JSON.parse(value) : null;
  },
  getAllStorage: () => {
    let storageItems: any = {};

    for (let i = 0; i < localStorage.length; i++) {
      let key: any = localStorage.key(i);
      if(key.indexOf(prefix) > -1) {
        let value = localStorage.getItem(key);
        storageItems[key.replace('amf_utm_', '')] = formatValue(value);
      }
    }
  
    return storageItems;
  }
};

const formatValue = (value: any) => {
  let formatValue = value.replace(/"/g, '');

  // check of integer
  const checkNumber = parseInt(formatValue);
  const isNumber = isNaN(checkNumber) ? formatValue : checkNumber;
  return isNumber;
}

export default storage;