import storage from '@/modules/storage.module';

export const getUrl = window.location.href;
export const getQuery = getParametersFromURL();

interface IQuery {
  [key: string]: string;
}

function getParametersFromURL() {
  const queryString = window.location.search;
  const urlParams = new URLSearchParams(queryString);
  const params: IQuery = {};

  for (const [key, value] of urlParams.entries()) {
    params[key] = value;
  }

  return params;
}

function findAndSavaUTM() {
  const params = getParametersFromURL();

  for(const param of Object.keys(params)) {
    const formatUTM = param.toLocaleLowerCase();
    if(formatUTM.indexOf('utm') > -1) {
      storage.setItem(param, params[param]);
    }
  }
}

export function initUTM() {
  findAndSavaUTM();
}